package cn.com.qmth.stmms.common.support;

import org.apache.commons.lang3.StringUtils;
import org.springframework.core.convert.converter.Converter;
import org.springframework.core.convert.converter.ConverterFactory;

import cn.com.qmth.stmms.biz.exception.StatusException;

@SuppressWarnings("rawtypes")
public class ValuedEnumConverter implements ConverterFactory<String, Enum> {

    @Override
    public <T extends Enum> Converter<String, T> getConverter(Class<T> targetType) {
        return new StringToEnum<>(targetType);
    }

    private class StringToEnum<T extends Enum<T>> implements Converter<String, T> {

        private Class<T> targetType;

        public StringToEnum(Class<T> targetType) {
            this.targetType = targetType;
        }

        @Override
        public T convert(String source) {
            if (StringUtils.isBlank(source)) {
                return null;
            }
            try {
                return (T) Enum.valueOf(targetType, source);
            } catch (Exception e) {
                throw new StatusException("枚举值：" + source + "不存在");
            }
        }
    }
}
